/**
 * 
 */
package org.eclipse.example.internal.mailservice;

import java.util.Dictionary;
import java.util.Hashtable;

import org.eclipse.equinox.http.helper.BundleEntryHttpContext;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.http.HttpService;
import org.springframework.context.ApplicationContext;
import org.springframework.web.context.ContextLoaderServlet;
import org.springframework.web.servlet.DispatcherServlet;

import de.kolbware.springOsgiUtil.context.BundleContextLoaderServlet;
import de.kolbware.springOsgiUtil.context.OSGiDispatcherServlet;
import de.kolbware.springOsgiUtil.http.AppContextAwareHttpServiceTracker;

public class HttpServiceTracker extends AppContextAwareHttpServiceTracker {


	public HttpServiceTracker(BundleContext context) {
		super(context);
	}
	
	@Override
	protected void addServiceInternal(ApplicationContext appContext, HttpService httpService) throws Exception {
		
		BundleEntryHttpContext commonContext = new BundleEntryHttpContext(context.getBundle(), "/remoteservices");
		
		Dictionary<String, String> initparams = new Hashtable<String, String>();
		initparams.put("load-on-startup", "1");
		
		ContextLoaderServlet contextloaderListener = new BundleContextLoaderServlet(appContext, context);
		httpService.registerServlet("/init-context-loader-mailexample", contextloaderListener, initparams, commonContext);
		
		DispatcherServlet dispatcherServlet = new OSGiDispatcherServlet(context);
		dispatcherServlet.setContextConfigLocation("META-INF/remoting-context.xml");
		initparams = new Hashtable<String, String>();
		initparams.put("servlet-name", "remoteservices");
		initparams.put("load-on-startup", "1");
		httpService.registerServlet("/remoteservices", dispatcherServlet, initparams, commonContext);
	}

	public void removedService(ServiceReference reference, Object service) {
		final HttpService httpService = (HttpService) service;
		httpService.unregister("/init-context-loader-mailexample"); //$NON-NLS-1$
		httpService.unregister("/remoteservices"); //$NON-NLS-1$			
		super.removedService(reference, service);
	}
}